
(* *)    
type material = { weight : int; value : int }

(* *)
let material_array = [|
  { weight = 11; value = 15 };
  { weight = 2; value = 3 };
  { weight = 3; value = 1 };
  { weight = 8; value = 5 };
  { weight = 2; value = 1 };
  { weight = 4; value = 4 }
|]

    
(* 制約条件 *)
let nsize = Array.length material_array
let wmax = 15

(* 全パターンを検索する場合 *)
let rec search_max w_res i =
  if i = nsize then 0
  else if w_res < material_array.(i).weight then search_max w_res (i+1)
  else max (search_max w_res (i+1)) ((search_max (w_res - material_array.(i).weight) (i+1)) + material_array.(i).value)

type tbl_value =
  | Undefined
  | Defined of int

let dp = Array.make_matrix (wmax+1) (nsize+1) Undefined
let rec search_max_dp w_res i =
  match (dp.(w_res).(i)) with
  | Defined ret -> ret
  | Undefined ->
      begin
	let res =
	  if i = nsize then 0
	  else if w_res < material_array.(i).weight then
	    search_max_dp w_res (i+1)	      
	  else
	    max (search_max_dp w_res (i+1)) ((search_max_dp (w_res - material_array.(i).weight) (i+1)) + material_array.(i).value)
	in
	dp.(w_res).(i) <- (Defined res);
	res
      end

let () =
  print_int (search_max wmax 0);
  print_string " ";
  print_int (search_max_dp wmax 0);
  print_endline ""
