
(* *)
type material = { weight : int; value : int }
let wmax = 15
type tbl_value =
  | Undefined
  | Defined of int

    
let m_arr1 = [|
  { weight = 11; value = 15 };
  { weight = 2; value = 3 };
  { weight = 3; value = 1 };
  { weight = 8; value = 5 };
  { weight = 2; value = 1 };
  { weight = 4; value = 4 }
|]

let nsize1 = lazy(Array.length m_arr1)
let dp1 = lazy(Array.make_matrix (wmax+1) (Lazy.force nsize1+1) Undefined)

let m_arr2 = [|
  { weight = 11; value = 15 };
  { weight = 2; value = 3 };
  { weight = 3; value = 1 };
  { weight = 8; value = 5 };
  { weight = 4; value = 4 }
|]

let nsize2 = lazy(Array.length m_arr2)
let dp2 = lazy(Array.make_matrix (wmax+1) (Lazy.force nsize2+1) Undefined)


(* 全パターンを検索する場合 *)
let rec search_max m_arr nsize w_res i =
  if i = nsize then 0
  else if w_res < m_arr.(i).weight then search_max m_arr nsize w_res (i+1)
  else max (search_max m_arr nsize w_res (i+1)) ((search_max m_arr nsize (w_res - m_arr.(i).weight) (i+1)) + m_arr.(i).value)


let rec search_max_dp m_arr nsize dp w_res i =
  match (dp.(w_res).(i)) with
  | Defined ret -> ret
  | Undefined ->
      begin
	let res =
	  if i = nsize then 0
	  else if w_res < m_arr.(i).weight then
	    search_max_dp m_arr nsize dp w_res (i+1)	      
	  else
	    max (search_max_dp m_arr nsize dp w_res (i+1)) ((search_max_dp m_arr nsize dp (w_res - m_arr.(i).weight) (i+1)) + m_arr.(i).value)
	in
	dp.(w_res).(i) <- (Defined res);
	res
      end

let () =
  let w1 = search_max m_arr1 (Lazy.force nsize1) wmax 0 in
  let w1' = search_max_dp m_arr1 (Lazy.force nsize1) (Lazy.force dp1) wmax 0 in
  let w2 = search_max m_arr2 (Lazy.force nsize2) wmax 0 in
  print_int w1;
  print_string " ";
  print_int w1';
  print_string " ";
  print_int w2;
  print_endline ""
